/* REXX  18.08.1997

CHecKMAIL v1.0alpha Written by Andrew Alexeenko (e-mail: chaos@falt.deep.ru,
                                                         2:5020/1101.2@fidonet,
                                                         7:1130/1101@fidonet
                                                         2:50/381.702@fidonet
                                                         117:117/1@milfornet)

This program is intended to notify user about incoming e-mail messages.
                                                    
usage: CHKMAIL.CMD      - load ;)
       CHKMAIL.CMD EXIT - force running part to exit

Thanks to Harry Bush for his FIDOTITL.CMD
*/
'@echo off'
ARG prm

install_dir='e:\work\rexx\chkmail'              /* chkmail's home dir */
icon_position='88,85'                           /* icon position on the desktop */
pop_address='194.186.127.199'                   /* POP3 server address */
pop_name='user'                                 /* your POP3 name */
pop_password='password'                         /* your POP3 password */
prog_name='E:\OS2.APL\PMMAIL\PMMAIL\PMMAIL.EXE' /* your mail program  */
prog_path='E:\OS2.APL\PMMAIL\PMMAIL'            /* and it's */ 
prog_param=''                                   /* configuration */
check_for_new_mail_seconds=300                  /* Hmmm... %)  */
beep_on_new_mail=1

IF prm='EXIT' THEN DO
    SAY
    rc=lineout(install_dir'\exit.cm','')
    'exit'
    END
call rxfuncadd sysloadfuncs, rexxutil, sysloadfuncs;
call sysloadfuncs;
rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

rc=SysDestroyObject("<MAILSTAT>");
rc=SysCreateObject("WPProgram","Mail Status","<WP_DESKTOP>",,
"OBJECTID=<MAILSTAT>;EXENAME="prog_name";PARAMETERS="prog_param";STARTUPDIR="prog_path";ICONFILE="install_dir"\xmail.ico;"||,
"ICONPOS="icon_position";","UPDATE");

addr.port = 110
addr.addr = pop_address
addr.family = AF_INET

lup=1
DO WHILE lup
    retcode=checkmail()
    SELECT
        WHEN retcode=-1 THEN DO
            rc=SysCreateObject("WPProgram","No connection","<WP_DESKTOP>",,
            "OBJECTID=<MAILSTAT>;ICONFILE="install_dir"\xmail.ico;","UPDATE");
            rc=SysSetObjectData("<MAILSTAT>",,
            "TITLE=No connection;");
            END
        WHEN retcode=0 THEN DO
            rc=SysCreateObject("WPProgram","No new msgs","<WP_DESKTOP>",,
            "OBJECTID=<MAILSTAT>;ICONFILE="install_dir"\nomail.ico;","UPDATE");
            rc=SysSetObjectData("<MAILSTAT>",,
            "TITLE=No new msgs;");
            END
        OTHERWISE
        rc=SysCreateObject("WPProgram",retcode" new msgs","<WP_DESKTOP>",,
        "OBJECTID=<MAILSTAT>;ICONFILE="install_dir"\newmail.ico;","UPDATE");
        rc=SysSetObjectData("<MAILSTAT>",,
        "TITLE="retcode" new msgs;");
        IF beep_on_new_mail=1 THEN
            say x2c('7')x2c('7')x2c('7')
        END
    IF STREAM(install_dir'\exit.cm','C','open read')='READY:' THEN DO
        lup=0
        rc = STREAM(install_dir'\exit.cm','C','close')
        'del 'install_dir'\exit.cm'
        END
    ELSE
        call SysSleep check_for_new_mail_seconds;
    END
rc=SysDestroyObject("<MAILSTAT>");
rc = SockClose(sock)
rc = SockDropFuncs()
'exit'

checkmail:
    sock = SockSocket(AF_INET, SOCK_STREAM, 0)
    IF sock>-1 THEN
        DO

            SAY ''
            SAY 'Connecting to 'pop_address
            rc = SockConnect(sock,"addr.")
            IF rc>-1 THEN
                SAY 'Connected to POP3 at 'pop_address
            ELSE DO
                SAY 'Unable to connect POP3, server may be down...'
                RETURN -1
                END
            DROP str1
            DROP str2
            DROP str3
            rc=SockRecv(sock,str1,80)
            rc=SockSend(sock,'USER 'pop_name''X2C('A'))
            rc=SockRecv(sock,str2,80)
            rc=SockSend(sock,'PASS 'pop_password''X2C('A'))
            rc=SockRecv(sock,str3,80)
            rc=SockClose(sock)
            PARSE VALUE str3 WITH str1 mes str2
            IF mes='0' THEN DO
                SAY 'There are no messages for 'pop_name
                RETURN 0
                END
            SAY 'There are 'mes' messages for 'pop_name
            RETURN mes
            END
    ELSE DO
        SAY 'Unable to get socket...'
        RETURN -1
